"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const alar = require("alar");
const init_1 = require("../../init");
exports.ViewEntry = global.app.views = new alar.ModuleProxy("app.views", init_1.SRC_PATH + "/views");
app.views.setLoader({
    cache: {},
    extension: ".html",
    load(file) {
        if (!this.cache[file]) {
            let contents = fs.readFileSync(file, "utf8");
            this.cache[file] = {
                render: () => {
                    return contents;
                }
            };
        }
        return this.cache[file];
    },
    unload(file) {
        delete this.cache[file];
    }
});
//# sourceMappingURL=load-views.js.map