"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const serveStatic = require("serve-static");
const startsWith = require("lodash/startsWith");
const index_1 = require("../bootstrap/index");
const path_1 = require("path");
const init_1 = require("../../init");
if (Array.isArray(app.config.statics)) {
    app.config.statics.forEach(path => {
        index_1.router.use(serveStatic(path_1.resolve(init_1.SRC_PATH, path)));
    });
}
else {
    for (let path in app.config.statics) {
        let options = app.config.statics[path], _path = path_1.resolve(init_1.SRC_PATH, path), handle = serveStatic(_path, options);
        index_1.router.use(async (req, res, next) => {
            if (options.prefix) {
                let prefix = typeof options.prefix == "string"
                    ? options.prefix
                    : _path.slice(init_1.SRC_PATH.length);
                if (startsWith(req.url, prefix + "/")) {
                    req.url = req.url.slice(prefix.length);
                    return handle(req, res, () => {
                        req.url = req["originalUrl"];
                        next();
                    });
                }
                else {
                    next();
                }
            }
            else {
                handle(req, res, next);
            }
        });
    }
}
//# sourceMappingURL=http-static.js.map