"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const util = require("util");
const events_1 = require("events");
const HideProtectedProperties = require("hide-protected-properties");
const get = require("lodash/get");
let Service = class Service extends events_1.EventEmitter {
    constructor() {
        super(...arguments);
        this.lang = app.config.lang;
    }
    i18n(text, ...replacements) {
        let mod = get(app.locales, this.lang);
        let defMod = get(app.locales, app.config.lang);
        let locale = null;
        let stmt;
        if (mod && mod.proto) {
            locale = mod.instance();
            locale[text] && (stmt = locale[text]);
        }
        if (stmt === undefined && defMod && defMod.proto) {
            locale = defMod.instance();
            locale[text] && (stmt = locale[text]);
        }
        (stmt === undefined) && (stmt = text);
        return util.format(stmt, ...replacements);
    }
    success(data, code = 200) {
        return {
            success: true,
            code,
            data,
        };
    }
    error(msg, code = 500) {
        msg = msg instanceof Error ? msg.message : msg;
        return {
            success: false,
            code,
            error: msg
        };
    }
};
Service = tslib_1.__decorate([
    HideProtectedProperties
], Service);
exports.Service = Service;
//# sourceMappingURL=Service.js.map