"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const http_1 = require("http");
const alar_1 = require("alar");
const init_1 = require("../../init");
class StatusException extends Error {
    constructor(code, message) {
        super(message || http_1.STATUS_CODES[code] || "Unknown error");
        this.code = code;
        Error.captureStackTrace(this, this.constructor);
    }
    get name() {
        return this.constructor.name;
    }
    toString() {
        return this.name + ": " + this.code + " " + this.message;
    }
    static from(err) {
        if (err instanceof this) {
            return err;
        }
        else if (err instanceof StatusException) {
            return Object.setPrototypeOf(err, this.prototype);
        }
        else if (err instanceof Error) {
            return new this(500, init_1.isDevMode ? err.message : null);
        }
        else {
            return new this(500, String(err));
        }
    }
}
exports.StatusException = StatusException;
alar_1.RpcChannel.registerError(StatusException);
//# sourceMappingURL=StatusException.js.map