"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const os = require("os");
const power_repl_1 = require("power-repl");
function getSockPath(name) {
    let hostname = app.config.server.hostname;
    let { port } = app.config.server.http;
    let baseDir = os.platform() === "win32" ? os.tmpdir() : "/tmp";
    Array.isArray(hostname) && (hostname = hostname[0]);
    return `${baseDir}/sfn/${port}/${name}.sock`;
}
function serve(name) {
    return power_repl_1.serve(getSockPath(name));
}
exports.serve = serve;
function connect(name, noStdout = false) {
    return power_repl_1.connect({
        path: getSockPath(name),
        noStdout
    });
}
exports.connect = connect;
//# sourceMappingURL=repl.js.map