"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
require("../env-fix");
let isTsNode = process.execArgv.join(" ").includes("ts-node");
let isMain = process.mainModule.filename === __filename;
!isTsNode && require("source-map-support/register");
require("reflect-metadata");
tslib_1.__exportStar(require("sfn-xss"), exports);
tslib_1.__exportStar(require("./init"), exports);
require("./core/bootstrap/load-controllers");
require("./core/bootstrap/load-services");
require("./core/bootstrap/load-models");
require("./core/bootstrap/load-utils");
require("./core/bootstrap/load-views");
require("./core/bootstrap/load-locales");
require("./core/bootstrap/load-hooks");
tslib_1.__exportStar(require("./core/tools/interfaces"), exports);
tslib_1.__exportStar(require("./core/tools/StatusException"), exports);
tslib_1.__exportStar(require("./core/tools/functions"), exports);
tslib_1.__exportStar(require("./core/tools/upload"), exports);
tslib_1.__exportStar(require("./core/tools/Hook"), exports);
tslib_1.__exportStar(require("./core/tools/Schedule"), exports);
tslib_1.__exportStar(require("./core/tools/Service"), exports);
tslib_1.__exportStar(require("./core/tools/MessageChannel"), exports);
tslib_1.__exportStar(require("./core/controllers/HttpController"), exports);
tslib_1.__exportStar(require("./core/controllers/WebSocketController"), exports);
tslib_1.__exportStar(require("./core/bootstrap/index"), exports);
require("./core/bootstrap/load-config");
const fs_extra_1 = require("fs-extra");
const functions_1 = require("./core/tools/functions");
const module_1 = require("./core/tools/internal/module");
if (!app.isCli) {
    const tryImport = functions_1.createImport(require);
    let bootstrap = app.APP_PATH + "/bootstrap/index";
    functions_1.moduleExists(bootstrap) && tryImport(bootstrap);
    fs_extra_1.pathExists(app.hooks.path).then(async (exists) => {
        exists && (await module_1.importDirectory(app.hooks.path));
    });
}
isMain && app.serve().then(() => app.rpc.connectAll(true));
//# sourceMappingURL=index.js.map